#include "ddos.h"
#include <sys/stat.h>
#include <string.h>

/* Copy on track 16 */
#define DIRTRACK 20

void seektodir(FILE *fp, struct diskinfo *h) {
    long tocloc;

    tocloc = h->heads * DIRTRACK * h->sectors * 256 + 512 + h->vdksize;
    fseek(fp, tocloc, SEEK_SET);
}

long imagesize(FILE *fp) {
    struct stat sb;

    if(fstat(fileno(fp), &sb) == -1) {
        perror("imagesize");
        exit(2);
    }

    return sb.st_size;
}

void vdkhead(FILE *fp, struct diskinfo *h) {
    int j, exp;
    char buffer[2];
    long dsksize, sectors;

    dsksize = imagesize(fp);
    fread(buffer, 1, 2, fp);   /* Magic 'dk' */
    if (buffer[0] != 'd' && buffer[1] != 'k') {
        h->vdksize = 0;
        if (dsksize == 161280L) {
            h->heads = 1;
            h->tracks = 35;
            h->sectors = 18;
        } else if (dsksize == 184320L) {
            h->heads = 1;
            h->tracks = 40;
            h->sectors = 18;
        } else if (dsksize == 368640L) {
            h->heads = 2;
            h->tracks = 40;
            h->sectors = 18;
        } else if (dsksize == 737280L) {
            h->heads = 2;
            h->tracks = 80;
            h->sectors = 18;
        } else {
            fprintf(stderr, "Disk has unrecognized dimensions\n");
            exit(1);
        }
        return;
    }
    fread(buffer, 1, 2, fp); /* Header length (little-endian) */
    h->vdksize = buffer[0] + buffer[1] * 256;

    exp = getc(fp); /* VDK version */
    exp = getc(fp); /* VDK backwards compatibility version */
    if (exp != 0x10) {
        printf("Unexpected byte 5: %d\n", exp);
        exit(1);
    }
    exp = getc(fp); /* Identity of file source */

    exp = getc(fp); /* Version of file source */

    h->tracks = getc(fp); /* Number of cylinders */
    h->heads = getc(fp);  /* Number of heads */
    exp = getc(fp);  /* Flags */
    exp = getc(fp);  /* Compression flags (bits 0-2) and name length (bits 3-7) */

    dsksize -= h->vdksize;
    sectors = dsksize / h->heads / h->tracks / 256;
    h->sectors = (int)(sectors & 0xFFFF);
}

void writehead(FILE *fp, struct diskinfo *h) {
    int headersize;
    char buffer[2];

    fwrite("dk", 2, 1, fp);
    headersize = 12 + strlen(h->diskname);
    buffer[0] = (char) headersize;
    buffer[1] = '\0';
    fwrite(buffer, 2, 1, fp);
    buffer[0] = '\x10';  // VDK version
    buffer[1] = '\x10';
    fwrite(buffer, 2, 1, fp);
    buffer[0] = '\x03'; // Source ID
    buffer[1] = '\x01';
    fwrite(buffer, 2, 1, fp);
    buffer[0] = (char) h->tracks;
    buffer[1] = (char) h->heads;
    fwrite(buffer, 2, 1, fp);
    buffer[0] = '\x00'; // Flags
    buffer[1] = (char) (strlen(h->diskname) << 3);
    fwrite(buffer, 2, 1, fp);
    fwrite(h->diskname, strlen(h->diskname), 1, fp);

}
