#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include "ddos.h"

int readhead(FILE *fp) {
    int j, exp;
    char buffer[32];
    int headersize, heads, tracks;
    long dsksize, sectors;

    /* Magic 'dk' */
    fread(buffer, 1, 2, fp);
    if (buffer[0] != 'd' && buffer[1] != 'k') {
        fprintf(stderr, "This is not a VDK disk\n");
        return 0;
    }
    /* Header length */
    fread(buffer, 1, 2, fp);
    headersize = buffer[0] + buffer[1] * 256;

    printf("Header size    : %d\n", headersize);
    exp = getc(fp);
    printf("VDK Version : %d\n", exp);

    exp = getc(fp);
    if (exp != 0x10) {
        printf("Unexpected byte 5: %d\n", exp);
        exit(1);
    }
    exp = getc(fp);
    printf("Source  : %d\n", exp);

    exp = getc(fp);
    printf("Source version: %d\n", exp);

    tracks = getc(fp);
    printf("Tracks  : %d\n", tracks);

    heads = getc(fp);
    printf("Heads  : %d\n", heads);

    exp = getc(fp);
    printf("Flags  : %d\n", exp);

    exp = getc(fp);
    exp >>= 3;
    printf("Name length: %d\n", exp);
    if (exp != 0) {
        printf("Title: ");
        fread(buffer, 1, exp,fp);
        for (j = 0; j < exp; j++) {
            putchar(buffer[j]);
        }
        putchar('\n');
    }

    fseek(fp, 0, SEEK_END);
    dsksize = ftell(fp) - headersize;
    printf("Disk size: %ld\n", dsksize);
    sectors = dsksize / heads / tracks / 256;
    printf("# Sectors: %ld\n", sectors);
    return headersize;
}


int main(int argc, char *argv[]) {
    FILE *fp;
    int i, sz;

    for (i = 1; i < argc; i++) {
        printf("%s\n", argv[i]);
        printf("======================\n");
        fp = fopen(argv[i], "r");
        sz = readhead(fp);
        printf("\n");
        fclose(fp);
    }
}

